//---------------------------------------------------------------------------
/*
  V1.2 - 10/10/07 - Servidor com suporte aos Microterminais: GE750, GE760, MT740, MT720
  								-	Serial: Agora  possvel escolher a porta serial e o handshaking
  								- Adicionada as funes de carto magntico e impressora
  								- Adicionada funo para ecoar no display, caracteres vindos do teclado
  								- Adicionado funo de gravar teclado 44 teclas (GE750 e MT740)
  V1.1 - 28/03/07 - Adicionado a funo mt_settermserial
                  - Corrigido BUG em BtnSendCfgSerClick
*/
#include <vcl.h>
#include <stdio.h>
#include <stdlib.h>
#include <shellapi.h>
#include <jpeg.hpp>
#include <fcntl.h>
#include <io.h>
#include <sys\stat.h>
#include <inifiles.hpp>
#pragma hdrstop

#include "pmtg.h"  //chamadas da DLL

#include "Unit1.h"
#include "structs.h"
#include "ids.h"

#define COMUNICATION_MSG  WM_USER + 1
#define CONNECT_MSG       WM_USER + 2

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

short selectedterm=-1;

//---------------------------------------------------------------------------

int thID;
bool enviaadv;
int usoadv[255]={0};  //controla IDs que esto sendo atualizado;

//---------------------------------------------------------------------------

char datahorabuf[32];
char *datahora(void)
{
  strcpy(datahorabuf,DateToStr(Date()).c_str());
  strcat(datahorabuf," - ");
  strcat(datahorabuf,TimeToStr(Time()).c_str());
  return datahorabuf;
}

//---------------------------------------------------------------------------

void MostraConfig(TSetupTCP *config)
{
  Form1->Edit1->Text = mt_inet_ntoa_inv(config->microT_IP);
  Form1->Edit12->Text = mt_inet_ntoa_inv(config->server_IP);
  Form1->Edit2->Text = mt_inet_ntoa_inv(config->msknet_IP);

  if (config->bDHCP) Form1->CBdynamicip->Checked = true; else Form1->CBdynamicip->Checked = false;
}

//---------------------------------------------------------------------------

void MostraExConfig(TExSetupTCP *config)
{
  Form1->Edit3->Text = mt_inet_ntoa_inv(config->gateway);
  Form1->Edit4->Text = mt_inet_ntoa_inv(config->nameserver);
  Form1->Edit5->Text = config->myname;
}

//---------------------------------------------------------------------------

void MostraConfigSerial(ARG_COM_SETUPSERIAL *config)
{
  Form1->ComboBox1->Text = IntToStr(config->Setup.baud);
  Form1->ComboBox2->Text = IntToStr(config->Setup.bits);
  Form1->ComboBox3->ItemIndex = config->Setup.parity;
  Form1->ComboBox4->Text = IntToStr(config->Setup.stops);
  Form1->ComboBox6->ItemIndex = config->Setup.handshaking;
}

//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  DragAcceptFiles(Form1->Handle,true);  //accept drag and drop files

  if (mt_startserver(Form1->Handle,CONNECT_MSG,COMUNICATION_MSG)==1)
  {
    Form1->Memo1->Lines->Add(AnsiString("##### Servidor Inicializado - ") + AnsiString(datahora()) + AnsiString(" #####"));
  }
  else
  {
    ShowMessage("Falha na Inicializao");
  }
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  mt_finishserver();
}

//---------------------------------------------------------------------------

void __fastcall TForm1::WndProc(Messages::TMessage &Message)
{
  char memostr[256];
  //############# RECEBE DADOS DO TC504 ########################
  if (Message.Msg == COMUNICATION_MSG)
  {
    switch(Message.WParam)
    {
      case IDcGetCharTerm:  //TC 504 ENVIOU DADOS DO TECLADO
      {
        sprintf(memostr,"(%s) %s >> Tecla: %c",datahora(),mt_ipfromid(Message.LParamLo),(char)Message.LParamHi);
        Form1->Memo1->Lines->Add(memostr);
        if (CheckBox6->Checked) mt_dispch(Message.LParamLo,(char)Message.LParamHi);
        return;
      }
      case IDbGetBinSerial:  //TC 504 ENVIOU DADOS DA SERIAL
      {
        char buf[1024];
        int nbr;
        int sercom;

        nbr = mt_getserial(Message.LParamLo,&sercom,buf);
        if (nbr>0)
        {
            buf[nbr]=0;
            sprintf(memostr,"(%s) %s >> Serial: %s",datahora(),mt_ipfromid(Message.LParamLo),buf);
            Form1->Memo1->Lines->Add(memostr);
        }
        return;
      }
      case IDbReadEditString:
        char buf[41];
        mt_geteditstring(Message.LParamLo,buf);
        sprintf(memostr,"(%s) %s >> EditString: %s (%d)",datahora(),mt_ipfromid(Message.LParamLo),buf,Message.LParamHi);
        //sprintf(memostr,"(%s) %s >> EditString: %s",datahora(),mt_ipfromid(Message.LParamLo),buf);
        Form1->Memo1->Lines->Add(memostr);
        break;

      case IDvGetSetupTCP+1:  //TC 504 ENVIOU CONFIGURAO
      {
        TSetupTCP config;

        sprintf(memostr,"(%s) %s >> Configurao Ethernet recebida.",datahora(),mt_ipfromid(Message.LParamLo));
        Form1->Memo1->Lines->Add(memostr);

        if (mt_getconfig(Message.LParamLo,&config))
        {
          MostraConfig(&config);
        }

        return;
      }
      case IDvGetSetupSerial+1:
      {
        ARG_COM_SETUPSERIAL config;

        sprintf(memostr,"(%s) %s >> Configurao Serial recebida.",datahora(),mt_ipfromid(Message.LParamLo));
        Form1->Memo1->Lines->Add(memostr);

        if (mt_getconfigserial(Message.LParamLo,&config))
        {
          MostraConfigSerial(&config);
        }

        break;
      }

      case IDvGetExSetupTCP+1:
      {
        TExSetupTCP config;
        sprintf(memostr,"(%s) %s >> Configurao Ex-Ethernet recebida.",datahora(),mt_ipfromid(Message.LParamLo));
        Form1->Memo1->Lines->Add(memostr);

        if (mt_getexconfig(Message.LParamLo,&config))
          MostraExConfig(&config);
        return;
      }

/*      case IDvGetSetupUpdate+1:
      {
        TSetupUpdate config;
        sprintf(memostr,"(%s) %s >> Configurao de Atualizao recebida.",datahora(),mt_ipfromid(Message.LParamLo));
        Form1->Memo1->Lines->Add(memostr);

        if (mt_getconfigupdate(Message.LParamLo,&config))
          MostraConfigUpdate(&config);
        return;
      }*/

      case IDbGetEnableKey+1:
        sprintf(memostr,"(%s) %s >> EnableKey: %2X",datahora(),mt_ipfromid(Message.LParamLo),(char)Message.LParamHi);
        Form1->Memo1->Lines->Add(memostr);
        break;
      case IDbGetCapsLock+1:
        sprintf(memostr,"(%s) %s >> CapsLock: %2X",datahora(),mt_ipfromid(Message.LParamLo),(char)Message.LParamHi);
        Form1->Memo1->Lines->Add(memostr);
        break;
      case IDbGetNumLock+1:
        sprintf(memostr,"(%s) %s >> NumLock: %2X",datahora(),mt_ipfromid(Message.LParamLo),(char)Message.LParamHi);
        Form1->Memo1->Lines->Add(memostr);
        break;
      case IDbGetEnableSerial+1:
        sprintf(memostr,"(%s) %s >> EnableSerial: %4X",datahora(),mt_ipfromid(Message.LParamLo),(int)Message.LParamHi);
        Form1->Memo1->Lines->Add(memostr);
        break;
      case IDbGetEditString+1:
        sprintf(memostr,"(%s) %s >> EditString Status: %4X",datahora(),mt_ipfromid(Message.LParamLo),(int)Message.LParamHi);
        Form1->Memo1->Lines->Add(memostr);
        break;

      case IDbReadBuffCard:  //TC 504 ENVIOU DADOS DA SERIAL
      {
        ARG_CARD cardbuf;
        char buf[129];
        int sercom;

        if (mt_getcardbuf(Message.LParamLo,&cardbuf)>0)
        {
          buf[0]=0;
          if (cardbuf.status)
          {
            strncpy(buf,cardbuf.card,128);
            buf[128]=0;
          }
          sprintf(memostr,"(%s) %s >> IDbReadBuffCard: %s (%d)",datahora(),mt_ipfromid(Message.LParamLo),buf,cardbuf.status);
          Form1->Memo1->Lines->Add(memostr);
        }
        return;
      }
      case IDbGetCard+1:
        sprintf(memostr,"(%s) %s >> IDbGetCard: %4X",datahora(),mt_ipfromid(Message.LParamLo),(int)Message.LParamHi);
        Form1->Memo1->Lines->Add(memostr);
        break;

      case IDcInitPrn+1:
        sprintf(memostr,"(%s) %s >> IDcInitPrn: %4X",datahora(),mt_ipfromid(Message.LParamLo),(int)Message.LParamHi);
        Form1->Memo1->Lines->Add(memostr);
        break;

      case IDcGetStatusPrn+1:
        sprintf(memostr,"(%s) %s >> IDcGetStatusPrn: %4X",datahora(),mt_ipfromid(Message.LParamLo),(int)Message.LParamHi);
        Form1->Memo1->Lines->Add(memostr);
        break;

     /* case IDvUpdate:  //RESPOSTA AO COMANDO DE ATUALIZAO (LParamHi=1 OK, LParamHi=0 FAIL)
      {
        char straux[2048];
        extern char htmlindexhead[2048];
        extern char htmlfoot[2048];

        if (Message.LParamHi==1)
          sprintf(memostr,"(%s) %s >> Terminal Sendo Atualizado.",datahora(),mt_ipfromid(Message.LParamLo));
        else
          sprintf(memostr,"(%s) %s >> Erro Atualizado Terminal.",datahora(),mt_ipfromid(Message.LParamLo));
        Form1->Memo1->Lines->Add(memostr);

        return;
      }*/
      //case IDvSetSetupTCP+1:
      case IDvLive+1:
      case IDvSetBeep+1:
      case IDvSetBeepKey+1:

      //TECLADO
      case IDvSetEnableKey+1:
      case IDvSetCapsLock+1:
      case IDvSetNumLock+1:
      case IDbProgramKbd+1:

      //LCD
      case IDvBackSpace+1:
      case IDvCarRet+1:
      case IDvLineFeed+1:
      case IDvFormFeed+1:
      case IDvGoToXY+1:
      case IDvGoToXYRef+1:
      case IDbReadEditString+1:
      case IDvSetEditString+1:
      case IDvDispStr+1:
      case IDvDispCh+1:
      case IDvDispClrLn+1:

      //SERIAL
      case IDvSetEnableSerial+1:
      case IDbSendBinSerial+1:
      case IDbSetSetupSerial+1:

      //CARTO
      case IDvSetCard+1:

      //IMPRESSORA
      case IDcSendPrn+1:

      //NEW ADDED
      //case IDvSetExSetupTCP+1:
      case IDvSetSetupUpdate+1:
        sprintf(memostr,"(%s) %s >> (ID:%4X) %2X",datahora(),mt_ipfromid(Message.LParamLo),Message.WParam,(unsigned short)Message.LParamHi);
        Form1->Memo1->Lines->Add(memostr);
        break;
    }
  }

  //############# TC504 ESTA CONECTANDO/DISCONECTADO ###########################
  else if (Message.Msg == CONNECT_MSG)
  {
    AnsiString straux;

    straux = mt_inet_ntoa(Message.WParam);
    straux += ":";
    straux += Message.LParamHi;

    if (Message.LParamLo)  //CONECTANDO
    {
      sprintf(memostr,"(%s) %s Conectou",datahora(),mt_inet_ntoa(Message.WParam));
      Form1->Memo1->Lines->Add(memostr);

      ListBox1->Items->Add(straux);
      if (ListBox1->Items->Count == 1)
      {
        selectedterm = Message.LParamHi;
        ListBox1->ItemIndex = 0;
      }
    }
    else  //DESCONECTADO
    {
      if (selectedterm==Message.LParamHi) selectedterm=-1;
      for (int ci=0;ci < ListBox1->Items->Count;ci++)
      {
        if (ListBox1->Items->Strings[ci] == straux)
        {
          ListBox1->Items->Delete(ci);
          break;  //sair do for
        }
      }
      sprintf(memostr,"(%s) %s Desconectou",datahora(),mt_inet_ntoa(Message.WParam));
      Form1->Memo1->Lines->Add(memostr);
    }
    return;
  }

  TForm::WndProc(Message);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnClearClick(TObject *Sender)
{
  Form1->Memo1->Lines->Clear();
}

//---------------------------------------------------------------------------

void __fastcall TForm1::ListBox1Click(TObject *Sender)
{
  for (int i = 0; i < ListBox1->Items->Count; i++)
  {
    if (ListBox1->Selected[i])
    {
      char *ptr;
      char straux[20];

      strcpy(straux,ListBox1->Items->Strings[i].c_str());
      ptr = strchr(straux,':');
      if (ptr==NULL) return;
      ptr++;
      selectedterm = atoi(ptr);
    }
  }
}

//---------------------------------------------------------------------------

void __fastcall TForm1::ListBox1KeyPress(TObject *Sender, char &Key)
{
  for (int i = 0; i < ListBox1->Items->Count; i++)
  {
    if (ListBox1->Selected[i])
    {
      char *ptr;
      char straux[20];

      strcpy(straux,ListBox1->Items->Strings[i].c_str());
      ptr = strchr(straux,':');
      if (ptr==NULL) return;
      ptr++;
      selectedterm = atoi(ptr);
    }
  }
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnRestartClick(TObject *Sender)
{
  int ret;

  ret = mt_restart(selectedterm);
  //if (ret == 0)
  //  ShowMessage(currlang.alert.reqrestart);
  //else if (ret == -1)
  //  ShowMessage(currlang.alert.version20);
}

//---------------------------------------------------------------------------
//---  R E D E  -------------------------------------------------------------
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnSendCfgClick(TObject *Sender)
{
  TSetupTCP config;

  config.microT_IP = mt_inet_addr_inv(Edit1->Text.c_str());
  config.server_IP = mt_inet_addr_inv(Edit12->Text.c_str());
  config.msknet_IP = mt_inet_addr_inv(Edit2->Text.c_str());
  if (Form1->CBdynamicip->Checked) config.bDHCP = 1; else config.bDHCP = 0;

  if (mt_sendconfig(selectedterm,&config)<1)
    ShowMessage("Erro enviando comando.");
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnPedeCfgClick(TObject *Sender)
{
  if (mt_reqconfig(selectedterm)<=0)
    ShowMessage("Erro requisitando Configurao.");
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnPedeExCfgClick(TObject *Sender)
{
  if (mt_reqexconfig(selectedterm)<=0)
    ShowMessage("Erro requisitando Configurao.");
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnSendExCfgClick(TObject *Sender)
{
  TExSetupTCP config;

  config.gateway = mt_inet_addr_inv(Edit3->Text.c_str());
  config.nameserver = mt_inet_addr_inv(Edit4->Text.c_str());
  strcpy(config.myname,Edit5->Text.c_str());

  if (mt_sendexconfig(selectedterm,&config)<1)
    ShowMessage("Erro enviando comando.");
}

//---------------------------------------------------------------------------
//---  L C D  ---------------------------------------------------------------
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnBackClick(TObject *Sender)
{
  mt_backspace(selectedterm);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnCarRetClick(TObject *Sender)
{
  mt_carret(selectedterm);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnLineFeedClick(TObject *Sender)
{
  mt_linefeed(selectedterm);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnFormFeedClick(TObject *Sender)
{
  mt_formfeed(selectedterm);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnGotoXYClick(TObject *Sender)
{
  mt_gotoxy(selectedterm,StrToInt(EdtXYa->Text),StrToInt(EdtXYb->Text));
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnGotoXYRefClick(TObject *Sender)
{
  mt_gotoxyref(selectedterm,StrToInt(EdtXYRefa->Text),StrToInt(EdtXYRefb->Text));
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnDispStrClick(TObject *Sender)
{
  mt_dispstr(selectedterm,EdtDispStr->Text.c_str());
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnDispChClick(TObject *Sender)
{
  char ch;
  strncpy(&ch,EdtDispCh->Text.c_str(),1);
  mt_dispch(selectedterm,*EdtDispCh->Text.c_str());
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnClrLnClick(TObject *Sender)
{
  mt_dispclrln(selectedterm,StrToInt(EdtClrLn->Text));
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnHabEdtStrClick(TObject *Sender)
{
  int pass;

  if (CBEdtPass->Checked) pass=1;
  else pass=0;

  mt_seteditstring(selectedterm,Edit10->Text.c_str(),1,pass);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnDesHabEdtStrClick(TObject *Sender)
{
  mt_seteditstring(selectedterm,NULL,0,0);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnStatusClick(TObject *Sender)
{
  mt_reqeditstring(selectedterm);
}

//---------------------------------------------------------------------------
//---  T E C L A D O  ------------------------------------------------------
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnResetClick(TObject *Sender)
{
  mt_reset(selectedterm);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  TCheckBox *cb = (TCheckBox*)Sender;

  if (cb->Checked)
    mt_setenablekey(selectedterm,1);
  else
    mt_setenablekey(selectedterm,0);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
  TCheckBox *cb = (TCheckBox*)Sender;

  if (cb->Checked)
    mt_setcapslock(selectedterm,1);
  else
    mt_setcapslock(selectedterm,0);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox3Click(TObject *Sender)
{
  TCheckBox *cb = (TCheckBox*)Sender;

  if (cb->Checked)
    mt_setnumlock(selectedterm,1);
  else
    mt_setnumlock(selectedterm,0);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnGetEnbKeyClick(TObject *Sender)
{
  mt_getenablekey(selectedterm);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnGetCapsClick(TObject *Sender)
{
  mt_getcapslock(selectedterm);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnGetNumClick(TObject *Sender)
{
  mt_getnumlock(selectedterm);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnGravarTecladoClick(TObject *Sender)
{
  unsigned char buf[512];
  unsigned char bufout[512];
  unsigned char *ptr;
  unsigned char *ptrout;

  OpenDialog1->InitialDir = ExtractFilePath(ParamStr(0));
  if (OpenDialog1->Execute())
  {
    int handle;

    //handle = open(OpenDialog1->FileName.c_str(), S_IREAD);
    handle = open(OpenDialog1->FileName.c_str(), O_RDONLY | O_BINARY, S_IREAD);
    if (handle<0)
    {
      ShowMessage("Erro abrindo arquivo.");
      return;  //nao conseguiu abrir o arquivo
    }
    read(handle, buf, 512);
    close(handle);

    //tranladar bytes
    for(int page=0;page<5;page++)
    {
      int currpage = page * 0x80;

      for(int line=0;line<5;line++)
      {
        int currline = line * 0x10;
        ptr=&buf[currpage+0x30-currline];
        ptrout=&bufout[currpage+currline];
        for(int i=0;i<5;i++)
          ptrout[i]=ptr[4-i];
      }
    }

    mt_programkbd(selectedterm,bufout);
  }
}

//---------------------------------------------------------------------------
//---  S E R I A L  ---------------------------------------------------------
//---------------------------------------------------------------------------

int getcomport(AnsiString comport)
{
  if      (comport==AnsiString("COM1")) return 0;
  else if (comport==AnsiString("COM2")) return 1;
  else if (comport==AnsiString("COM3")) return 2;
  else if (comport==AnsiString("COM4")) return 3;
  else return -1;
}

void __fastcall TForm1::BtnSendBinSerClick(TObject *Sender)
{
  int comport;

  if (Form1->ComboBox5->ItemIndex<0) Form1->ComboBox5->ItemIndex=0;
  comport = getcomport(Form1->ComboBox5->Text);
  if (comport<0) {ShowMessage("Porta serial invlida"); return;}

  if (mt_sendbinserial(selectedterm,comport,Edit9->Text.c_str(),Edit9->Text.Length())<1)
    ShowMessage("Erro enviando comando.");
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnEnbSerClick(TObject *Sender)
{
  int comport;
  if (Form1->ComboBox5->ItemIndex<0) Form1->ComboBox5->ItemIndex=0;
  comport = getcomport(Form1->ComboBox5->Text);
  if (comport<0) {ShowMessage("Porta serial invlida"); return;}
  if (mt_getenableserial(selectedterm, comport)<1)
    ShowMessage("Erro enviando comando.");
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnPedeCfgSerClick(TObject *Sender)
{
  int comport;
  if (Form1->ComboBox5->ItemIndex<0) Form1->ComboBox5->ItemIndex=0;
  comport = getcomport(Form1->ComboBox5->Text);
  if (comport<0) {ShowMessage("Porta serial invlida"); return;}

  if (mt_reqconfigserial(selectedterm,comport)<1)
    ShowMessage("Erro enviando comando.");
}

//---------------------------------------------------------------------------

void __fastcall TForm1::BtnSendCfgSerClick(TObject *Sender)
{
  ARG_COM_SETUPSERIAL config;
  int comport;
  if (Form1->ComboBox5->ItemIndex<0) Form1->ComboBox5->ItemIndex=0;
  comport = getcomport(Form1->ComboBox5->Text);
  if (comport<0) {ShowMessage("Porta serial invlida"); return;}

  config.Com = comport;

  config.Setup.baud = StrToInt(Form1->ComboBox1->Text);
  config.Setup.bits = StrToInt(Form1->ComboBox2->Text);
  if ((config.Setup.bits<4) || (config.Setup.bits>8)) config.Setup.bits = 8;
  if (Form1->ComboBox3->ItemIndex<0) Form1->ComboBox3->ItemIndex=0;
  config.Setup.parity = Form1->ComboBox3->ItemIndex;
  config.Setup.stops = StrToInt(Form1->ComboBox4->Text);
  if (Form1->ComboBox6->ItemIndex<0) Form1->ComboBox6->ItemIndex=0;
  config.Setup.handshaking = Form1->ComboBox6->ItemIndex;

  if (mt_sendconfigserial(selectedterm,&config)<1)
    ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnFTPModeClick(TObject *Sender)
{
  mt_ftpmode(selectedterm);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnBeepKeyOnClick(TObject *Sender)
{
  if (mt_setbeepkey(selectedterm, 1)<1)
    ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnBeepOnClick(TObject *Sender)
{
  if(mt_setbeep(selectedterm, 1)<1)
    ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnBeepKeyOffClick(TObject *Sender)
{
  if (mt_setbeepkey(selectedterm, 0)<1)
    ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnBeepOffClick(TObject *Sender)
{
  if (mt_setbeep(selectedterm, 0)<1)
    ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  if (mt_sendsetcard(selectedterm,1)<1)
    ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  if (mt_sendsetcard(selectedterm,0)<1)
    ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
  if (mt_reqgetcard(selectedterm)<1)
    ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  if (mt_sendinitprn(selectedterm)<1)
    ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
  if (mt_reqgetstatusprn(selectedterm)<1)
    ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
  char buf[256];

  strcpy(buf,Edit7->Text.c_str());
  strcat(buf,"\n");

  if (mt_sendbinprn(selectedterm,buf,strlen(buf))<=0)
    ShowMessage("Erro enviando comando.");
  //if (mt_sendbinprn(selectedterm,Edit7->Text.c_str(),Edit7->Text.Length())<1)
  //  ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  TCheckBox *cb = (TCheckBox*)Sender;
  int comport;
  if (Form1->ComboBox5->ItemIndex<0) Form1->ComboBox5->ItemIndex=0;
  comport = getcomport(Form1->ComboBox5->Text);
  if (comport<0) {ShowMessage("Porta serial invlida"); return;}

  if (mt_setenableserial(selectedterm,comport,1)<1)
    ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
  TCheckBox *cb = (TCheckBox*)Sender;
  int comport;
  if (Form1->ComboBox5->ItemIndex<0) Form1->ComboBox5->ItemIndex=0;
  comport = getcomport(Form1->ComboBox5->Text);
  if (comport<0) {ShowMessage("Porta serial invlida"); return;}

  if (mt_setenableserial(selectedterm,comport,0)<1)
    ShowMessage("Erro enviando comando.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
  unsigned char buf[512];
  unsigned char bufout[512];
  unsigned char *ptr;
  unsigned char *ptrout;

  OpenDialog1->InitialDir = ExtractFilePath(ParamStr(0));
  if (OpenDialog1->Execute())
  {
    int handle;

    //handle = open(OpenDialog1->FileName.c_str(), S_IREAD);
    handle = open(OpenDialog1->FileName.c_str(), O_RDONLY | O_BINARY, S_IREAD);
    if (handle<0)
    {
      ShowMessage("Erro abrindo arquivo.");
      return;  //nao conseguiu abrir o arquivo
    }
    read(handle, buf, 512);
    close(handle);

    //tranladar bytes
    /*for(int page=0;page<5;page++)
    {
      int currpage = page * 0x80;

      for(int line=0;line<5;line++)
      {
        int currline = line * 0x10;
        ptr=&buf[currpage+0x30-currline];
        ptrout=&bufout[currpage+currline];
        for(int i=0;i<5;i++)
          ptrout[i]=ptr[4-i];
      }
    }*/
    memmove(bufout,buf,512);

    mt_programkbd(selectedterm,bufout);
  }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

void __fastcall TForm1::btnImprimirClick(TObject *Sender)
{
  int comport;

  if (rbFontePequena->Checked)
        comport=2;
  else if(rbFonteGrande->Checked)
        comport = 3;
  else
        {ShowMessage("Selecione o Tamanho da Fonte"); return;}

  if (mt_sendbinserial(selectedterm,comport,txtTextoImpressao->Text.c_str(),txtTextoImpressao->Text.Length())<1)
    ShowMessage("Erro enviando comando.");

}
//---------------------------------------------------------------------------

