package DLL;

import com.sun.jna.Native;
import com.sun.jna.Structure;
import com.sun.jna.win32.StdCallLibrary;

public interface Estrutura_Dados extends StdCallLibrary {

    Estrutura_Dados INSTANCE = (Estrutura_Dados) Native.loadLibrary("src/DLL/MTI_7000", Estrutura_Dados.class);

    //-----------------------------------------------------------------------------------------------------------
    //INICIALIZAÇÃO E FINALIZAÇÃO
    public int mt_startserver(int[] ptr, int conecmsg, int commumsg);

    public void mt_finishserver();
    //-----------------------------------------------------------------------------------------------------------

    //-----------------------------------------------------------------------------------------------------------
    //FUNÇÕES DE TRATAMENTO DE IP
    public String mt_ipfromid(int ID);
    //-----------------------------------------------------------------------------------------------------------

    //-----------------------------------------------------------------------------------------------------------
    //COMANDOS BÁSICOS PARA O TERMINAL
    public int mt_restart(int ID);
    //-----------------------------------------------------------------------------------------------------------

    //-----------------------------------------------------------------------------------------------------------
    //REDE
    public int mt_sendconfig(int ID, Structure config);

    public int mt_getconfig(int ID, Structure config);

    public int mt_reqconfig(int ID);

    public int mt_reqexconfig(int ID);

    public int mt_sendexconfig(int ID, Structure config);

    public int mt_getexconfig(int ID, Structure config);

    public String mt_inet_ntoa_inv(int oip);

    public String mt_inet_ntoa(int oip);

    public int mt_inet_addr_inv(String oip);
    //-----------------------------------------------------------------------------------------------------------

    //-----------------------------------------------------------------------------------------------------------
    //DISPLAY
    public int mt_backspace(int ID);

    public int mt_carret(int ID);

    public int mt_linefeed(int ID);

    public int mt_formfeed(int ID);

    public int mt_gotoxy(int ID, int lin, int col);

    public int mt_gotoxyref(int ID, int lin, int col);

    public int mt_dispstr(int ID, String str);

    public int mt_dispch(int ID, char ch);

    public int mt_dispclrln(int ID, int lin);

    public int mt_seteditstring(int ID, String Byte, boolean onoff, boolean password);

    public int mt_geteditstring(int ID, byte[] buf3);
    //-----------------------------------------------------------------------------------------------------------

    //-----------------------------------------------------------------------------------------------------------
    //TECLADO
    public int mt_setenablekey(int ID, boolean onoff);

    public int mt_setbeep(int ID, boolean onoff);

    public int mt_setbeepkey(int ID, int onoff);

    public int mt_getkey(int ID, byte[] buf);
    //-----------------------------------------------------------------------------------------------------------

    //-----------------------------------------------------------------------------------------------------------
    //SERIAL
    public int mt_setenableserial(int ID, byte com, boolean onoff);

    public int mt_sendbinserial(int ID, byte com, String Bin, byte tam);

    public int mt_sendbinserial(int ID, byte com, byte[] Bin, byte tam);

    public int mt_getserial(int ID, int[] sercom, byte[] buf);

    public int mt_sendconfigserial(int ID, Structure config);

    public int mt_reqconfigserial(int ID, byte com);

    public int mt_getconfigserial(int ID, Structure config);

    public int mt_settermserial(int ID, int com, int term, int onoff);
    //-----------------------------------------------------------------------------------------------------------

    //-----------------------------------------------------------------------------------------------------------
    //CARTÃO MAGNÉTICO
    public int mt_sendsetcard(int ID, boolean onoff);

    public int mt_getcardbuf(int ID, byte[] cardbuf);
    //-----------------------------------------------------------------------------------------------------------

    //Estrutura que recebe as configurações do ip cliente, ip servidor, máscara de rede e o ip dinâmico
    public static class Ethernet extends Structure {

        public int cliente;
        public int servidor;
        public int mascara;
        public int dinamico;
    }

    //Estrutura que recebe as configurações do gateway, dns e o nome do terminal
    public static class Dns extends Structure {

        public int gateway;
        public int dns;
        public byte[] terminal = new byte[16];
    }

    //Estrutura que recebe as configurações da serial
    public static class Receber_Serial extends Structure {

        public int baud_rate;
        public short bits;
        public short parity;
        public short stop;
        public byte handshake;
    }

    //Estrutura que envia as configurações da serial
    public static class Enviar_Serial extends Structure {

        public int baud_rate;
        public short bits;
        public short parity;
        public short stop;
        public byte handshake;
    }

    //Estrutura que envia as configurações da serial
    public static class Enviar_Serial_Auxiliar extends Structure {

        public byte com;
        public Enviar_Serial configuracao;
    }
}
