Attribute VB_Name = "Module1"
'SERVIDOR COM SUPORTE AOS MICROTERMINAIS: GE 750, GE 760, MT 740, MT720

'DECLARAO DE TIPOS, COMPONENTES, PROCEDURES E FUNES GERAIS

Public Type TTABSOCK
    TSOCK(0 To 255) As Long
End Type

Public Type TSetupTCP
    microT_IP(0 To 3) As Byte  'Endereo IP do terminal
    server_IP(0 To 3) As Byte 'Endereo IP do servidor
    msknet_IP(0 To 3) As Byte 'Mscara de rede
    bDHCP As Long '1 = IP dinmico, 0 = IP fixo
End Type

Public Type TExSetupTCP
    gateway(0 To 3) As Byte 'IP do gateway
    nameserver(0 To 3) As Byte 'IP do servidor de nomes
    myname(0 To 16) As Byte 'Nome do terminal
End Type

Public Type TSetupSerial
    baud(0 To 3) As Byte 'Baud Rate: 300 a 115.200
    bits(0 To 1) As Byte 'Data Bits
    parity(0 To 1) As Byte 'Paridade
    stops(0 To 1) As Byte 'Stop Bits
    handshaking As Byte '0 = Sem Hand Shaking, 1 = RTS/CTS
End Type

Public Type ARG_COM_SETUPSERIAL
    com As Byte
    Setup As TSetupSerial
End Type

Public Type ARG_CARD
    card(0 To 128) As Byte
    status As Long
End Type

'VARIVEIS

Global v_Hwnd As Long
Public MsgReceiveData As Long
Public tabcon As TTABSOCK
Public statusCard As Long
Public statusSerial As Long
Public statusEditString As Long

Public auxIP As String
Public id_selecionado As Long

'DECLARAO DE FUNES E ROTINAS

'AUXILIAR
Declare Function inet_ntoa Lib "ws2_32.dll" (ByVal id As Long) As Long
Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Any) As Long
Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As Long) As Long

'INICIALIZAO E FINALIZAO
Declare Function mt_startserver Lib "pmtg.dll" (ByRef mywhnd As Long, ByVal conecmsg As Integer, ByVal commumsg As Integer) As Long
Declare Sub mt_finishserver Lib "pmtg.dll" ()
Declare Function mt_connectlist Lib "pmtg.dll" () As TTABSOCK

'FUNES DE TRATAMENTO DE IP
Declare Function mt_inet_ntoa_inv Lib "pmtg.dll" (ByVal oip As Byte) As String
Declare Function mt_inet_addr_inv Lib "pmtg.dll" (ByVal oip As String) As Byte
Declare Function mt_inet_addr Lib "pmtg.dll" (ByVal oip As String) As Byte

'COMANDOS BSICOS PARA O TERMINAL
Declare Function mt_sendlive Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_restart Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_ftpmode Lib "pmtg.dll" (ByVal id As Long) As Long

'REDE
Declare Function mt_sendconfig Lib "pmtg.dll" (ByVal id As Long, ByRef config As TSetupTCP) As Long
Declare Function mt_reqconfig Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_getconfig Lib "pmtg.dll" (ByVal id As Long, ByRef config As TSetupTCP) As Long
Declare Function mt_sendexconfig Lib "pmtg.dll" (ByVal id As Long, ByRef configex As TExSetupTCP) As Long
Declare Function mt_reqexconfig Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_getexconfig Lib "pmtg.dll" (ByVal id As Long, ByRef configex As TExSetupTCP) As Long

'DISPLAY
Declare Function mt_backspace Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_carret Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_linefeed Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_formfeed Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_gotoxy Lib "pmtg.dll" (ByVal id As Long, ByVal lin As Integer, ByVal col As Integer) As Integer
Declare Function mt_gotoxyref Lib "pmtg.dll" (ByVal id As Long, ByVal lin As Integer, ByVal col As Integer) As Integer
Declare Function mt_dispstr Lib "pmtg.dll" (ByVal id As Long, ByVal str As String) As Long
Declare Function mt_dispch Lib "pmtg.dll" (ByVal id As Long, ByVal ch As Byte) As Long
Declare Function mt_dispclrln Lib "pmtg.dll" (ByVal id As Long, ByVal lin As Long) As Long
Declare Function mt_seteditstring Lib "pmtg.dll" (ByVal id As Long, ByVal str As String, ByVal OnOff As Long, ByVal PassWord As Long) As Long
Declare Function mt_reqeditstring Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_geteditstring Lib "pmtg.dll" (ByVal id As Long, ByRef buf As Byte) As Long

'TECLADO
Declare Function mt_setenablekey Lib "pmtg.dll" (ByVal id As Long, ByVal OnOff As Long) As Long
Declare Function mt_getenablekey Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_setcapslock Lib "pmtg.dll" (ByVal id As Long, ByVal OnOff As Long) As Long
Declare Function mt_getcapslock Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_setnumlock Lib "pmtg.dll" (ByVal id As Long, ByVal OnOff As Long) As Long
Declare Function mt_getnumlock Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_reset Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_setbeep Lib "pmtg.dll" (ByVal id As Long, ByVal OnOff As Long) As Long
Declare Function mt_setbeepkey Lib "pmtg.dll" (ByVal id As Long, ByVal OnOff As Long) As Long
Declare Function mt_getkey Lib "pmtg.dll" (ByVal id As Long, ByRef buf As Byte) As Long
Declare Function mt_programkbd Lib "pmtg.dll" (ByVal id As Long, ByRef codigo As Byte) As Long

'SERIAL
Declare Function mt_setenableserial Lib "pmtg.dll" (ByVal id As Long, ByVal com As Byte, ByVal OnOff As Long) As Long
Declare Function mt_getenableserial Lib "pmtg.dll" (ByVal id As Long, ByVal com As Byte) As Long
Declare Function mt_sendbinserial Lib "pmtg.dll" (ByVal id As Long, ByVal com As Byte, ByRef bin As Byte, ByVal tam As Byte) As Long
Declare Function mt_sendconfigserial Lib "pmtg.dll" (ByVal id As Long, ByRef config As ARG_COM_SETUPSERIAL) As Long
Declare Function mt_reqconfigserial Lib "pmtg.dll" (ByVal id As Long, ByVal com As Byte) As Long
Declare Function mt_getconfigserial Lib "pmtg.dll" (ByVal id As Long, ByRef config As ARG_COM_SETUPSERIAL) As Long
Declare Function mt_getserial Lib "pmtg.dll" (ByVal id As Long, ByRef sercom As Long, ByRef buf As Byte) As Long
Declare Function mt_settermserial Lib "pmtg.dll" (ByVal id As Long, ByVal com As Byte, ByVal term As Byte, ByVal OnOff As Long) As Long

'CARTO
Declare Function mt_sendsetcard Lib "pmtg.dll" (ByVal id As Long, ByVal OnOff As Long) As Long
Declare Function mt_reqgetcard Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_getcardbuf Lib "pmtg.dll" (ByVal id As Long, ByRef cardbuf As ARG_CARD) As Long

'IMPRESSORA
Declare Function mt_sendinitprn Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function mt_reqgetstatusprn Lib "pmtg.dll" (ByVal id As Long) As Long
Declare Function sendbinprn Lib "pmtg.dll" (ByVal id As Long, ByRef bin As Byte, ByVal tam As Byte) As Long


'AUXILIAR

'********************************************************************************************************
' Funo: StringFromPointer
'********************************************************************************************************
'
' Descrio: Transforma o ID de um terminal em um endereo IP
'
'********************************************************************************************************

Function StringFromPointer(ByVal lPointer As Long) As String
    Dim strTemp As String
    Dim lRetVal As Long

    'Prepara o buf strTemp
    strTemp = String$(lstrlen(ByVal lPointer), 0)
    
    'Copia a string para o buf strTemp
    lRetVal = lstrcpy(ByVal strTemp, ByVal lPointer)

    'Retorna a string
    If lRetVal Then
        StringFromPointer = strTemp
    End If
End Function

'********************************************************************************************************
' Funo: enviaIP
'********************************************************************************************************
'
' Descrio: Recebe o IP do terminal em formato string e transforma para formato de rede
'
'********************************************************************************************************

Function enviaIP(campo As String, b() As Byte)
Dim i As Integer
Dim controle As Integer
Dim posicao As Integer
Dim carac As String

Dim buffer As Byte
Dim buf(0 To 3) As Byte

        i = 0
        'Varivel que verificar se o byte est preparado para ser modificado na estrutura
        controle = 0
        'Posio do byte
        posicao = 3
    
        tamanho = Len(campo)
        
        While i <= tamanho
            'A varivel carac recebe um byte em formato de rede
            If Mid(campo, (i + 1), 1) <> "." And Mid(campo, (i + 1), 1) <> "" Then
                buffer = Asc(Mid(campo, (i + 1), 1))
                carac = carac & "" & Chr(buffer)
            Else
                controle = 1
            End If
            'Quando pronto, este byte  modificado na estrutura
            If controle = 1 Then
                b(posicao) = CByte(carac)
                posicao = posicao - 1
                controle = 0
                carac = ""
            End If
            i = i + 1
        Wend

End Function

'********************************************************************************************************
' Funo: HexToDec
'********************************************************************************************************
'
' Descrio: Converte os nmeros de hexadecimal para decimal
'
'********************************************************************************************************

Function HexToDec(HexValue As String) As Long
    HexToDec = Val("&h" & HexValue)
End Function

'********************************************************************************************************
' Funo: compara
'********************************************************************************************************
'
' Descrio: Verifica se o usurio digitou valores vlidos ('0' at '9' e de 'A' at 'F')
'
'********************************************************************************************************

Function compara(buf As String) As Byte
    If buf = "0" Or buf = "1" Or buf = "2" Or buf = "3" Or buf = "4" Or buf = "5" Or buf = "6" Or buf = "7" Or buf = "8" Or buf = "9" Or buf = "a" Or buf = "b" Or buf = "c" Or buf = "d" Or buf = "e" Or buf = "f" Or buf = "A" Or buf = "B" Or buf = "C" Or buf = "D" Or buf = "E" Or buf = "F" Then
       compara = 1
    Else
       compara = 0
    End If
End Function

'********************************************************************************************************
' Funo: converte
'********************************************************************************************************
'
' Descrio: Converte os nmeros de decimal para hexadecimal
'
'********************************************************************************************************

Function converte(str As String) As Byte
Dim str1 As String
Dim str1a As Integer
Dim str2 As String
Dim str2a As Integer
Dim soma As Integer
    
    str1 = (Mid(str, 1, 1))
    str2 = (Mid(str, 2, 1))
    
    str1a = 0
    str2a = 0
   
   Select Case str1
      Case (0): str1a = 0
      Case (1): str1a = 16
      Case (2): str1a = 32
      Case (3): str1a = 48
      Case (4): str1a = 64
      Case (5): str1a = 80
      Case (6): str1a = 96
      Case (7): str1a = 112
      Case (8): str1a = 128
      Case (9): str1a = 144
      Case ("a"): str1a = 160
      Case ("b"): str1a = 176
      Case ("c"): str1a = 192
      Case ("d"): str1a = 208
      Case ("e"): str1a = 224
      Case ("f"): str1a = 240
   End Select
   
    Select Case str2
      Case (0): str2a = 0
      Case (1): str2a = 1
      Case (2): str2a = 2
      Case (3): str2a = 3
      Case (4): str2a = 4
      Case (5): str2a = 5
      Case (6): str2a = 6
      Case (7): str2a = 7
      Case (8): str2a = 8
      Case (9): str2a = 9
      Case ("a"): str2a = 10
      Case ("A"): str2a = 10
      Case ("b"): str2a = 11
      Case ("B"): str2a = 11
      Case ("c"): str2a = 12
      Case ("C"): str2a = 12
      Case ("d"): str2a = 13
      Case ("D"): str2a = 13
      Case ("e"): str2a = 14
      Case ("E"): str2a = 14
      Case ("f"): str2a = 15
      Case ("F"): str2a = 15
   End Select
   
   soma = str1a + str2a
      
   converte = soma

End Function
